/*
                      JUMBO elettronica
                     http://www.jumboelettronica.altervista.org
                     jumboelettromania@gmail.com

         * Project name:    Test_WebServer_Mikroc_ESP8266_PIC18_V1


         * Copyright:       JUMBO elettronica
                            jumboelettronica.altervista.org
                            jumboelettromania.altervista.org
                            jumboelettromania@gmail.com

         * Revision History:
                              06/06/2020: initial release.
                           ** V.3.0 ********************************************* V.3.0
                              19/06/2020: Aggiunto aggiornamento pagina web con multi richieste.
                              21/06/2020: Completo.


         * Description:     Ripresa progetto web server con invio di immagini



         * Test configuration:
         MCU:             PIC18F14K22
         Dev.Board:       Centrale Universale 2
         Oscillator:      Interno, 16.0000 MHz * PLL = 64 MHz
         Ext. Modules:
         SW:              mikroC PRO for PIC V.7.2.0

         * NOTES:         - V.3.0: Aggiunto aggiornamento pagina web con multi richieste.
                                   Soddisfa fino a 4 richieste dal brouser nello stesso momento.




*/
// --- LED
 sbit led1   at LATC0_bit;
 sbit led2   at LATC1_bit;
 sbit led3   at LATC2_bit;
 sbit led4   at LATC3_bit;
 sbit led5   at LATC4_bit;
 sbit led6   at LATC5_bit;
// --- Analog
 sbit ana8   at RC6_bit;     // Analog 8
 sbit ana9   at RC7_bit;     // Analog 9
 // --- Button
 sbit but1   at RA0_bit;
 sbit but2   at RA1_bit;
 sbit but3   at RA2_bit;
 sbit but4   at RA3_bit;
 sbit but5   at RA4_bit;
 sbit but6   at RA5_bit;
// --- LED status and general
 sbit LED         at LATB4_bit;
 sbit LED_Status  at LATB6_bit;
 // --- USART
 sbit USART_Tx    at RB7_bit;
 sbit USART_Rx    at RB5_bit;
//
  extern const char AT[] =         "AT+";
 extern const char AT_CIPSEND[] = "CIPSEND=";
//
extern void WiFI_Configure();
extern void WiFi3_Init();
extern void esp8266_Send(const char *s);
//
// responses to parse
const OK = 5;
const ERROR = 2;
const NO_CHANGE = 3;
const FAIL = 4;
const READY = 5;
const busy = 6;
const CIPSEND = 7;
//
 char received_data[46];     // 25
 char transfer_data[27];
 char received_data_0[50] ; // absolute 0x100
 char received_data_1[50] ; // absolute 0x132
 char received_data_2[50] ; // absolute 0x164
 char received_data_3[50] ; // absolute 0x196
 char received_data_4[50] ; // absolute 0x1C8

unsigned short i;
unsigned int tmp;
char text[6];
//
char state;
char response_rcvd;
char responseID, response = 0;
 char buff_13, buff_14, buff_15, buff_16_;
 char buff_17, buff_18, buff_19, buff_20, buff_21, buff_22;
 char old_page;
 unsigned short ajax_response;        // Diversa pagine web, diversa risposta
//

//
 unsigned short get_resp_timeout;
//
unsigned short up_down;
 char id_temp;
 char id_list;
//

 typedef struct {
        unsigned on_send      : 1;
        unsigned response_IPD : 1;
        unsigned ESP_OK       : 1;
        unsigned closed       : 1;
        unsigned soft_AP      : 1;
 } Flags;
  Flags flag_;
//
 char gen_buff;
 char number=0;
 char cnt_response;  // Numero di ID

// --- Prototype
 void Delay_msec (unsigned int count_delay);  // Ritardo in msec.
 void Lampe_LED_Status();                     // 5 lampeggio LED per 1 sec.
//
 #include "Init_PIC18F14K22.c"
 #include "WiFI3_Routines.c"
 #include "ESP8266_Routine.c"
 #include "ESP8266_Int.c"
//
// ***************************************************************************** RITARDO
//
// *****************************************************************************
 void Delay_msec_ (unsigned short count_delay) {
  unsigned short i;
      for (i=count_delay; i > 0; i --) {
         Delay_ms (1);
        }
 }
// *****************************************************************************
//
// *****************************************************************************
 void UART_NewLine () {


 }
// ***************************************************************************** Byte to stringa
//
// ***************************************************************************** UART1_Write('2');
 void ByteToString (unsigned short value) {
 short buff;
//
      buff = value / 100;
       if (buff == 0) UART1_Write(' ');
        else UART1_Write(buff+0x30);
        value -= (buff*100);
         buff = value / 10;
          UART1_Write(buff+0x30);
        //   if (M_ritardo ==0) UART1_Write(',');    // Ritardo senza virgola
            value -= (buff*10);
             UART1_Write(value+0x30);
//
              UART_NewLine ();
 }
// ***************************************************************************** Main
//  #&$2w35w38w46w47$1w56w51w66w62$3w13w11w24w22;
// *****************************************************************************
 void main() {
 int  temp ;
 unsigned short count_LED, count, buf_1, buf_2;
 unsigned short tempor;
//
   Init_PIC ();       // while (1) {LED ^= 1; Delay_msec(200);}
    WiFi3_Init();
     Init_Interrupt ();
     flag_.soft_AP = 1; // Soft AP + station
       WiFI_Configure();
        state = 0;
         i = 0;
          old_page = '0';             // Pagina iniziale
           ADC_Init();
//
          flag_.response_IPD=0;
           cnt_response = 0;
//
     received_data_0[2] = 0xFF;
     received_data_1[2] = 0xFF;
     received_data_2[2] = 0xFF;
     received_data_3[2] = 0xFF;
     received_data_4[2] = 0xFF;
 //

    while (1) {
      temp++;
       if (temp >=50000) {
         LED ^= 1;
          temp = 0;
       }

// --- Richiesta dal brouser                                                       // 19/06/2020  V.3.0
       if (cnt_response > 0) {
        cnt_response -= 1;
         if (cnt_response >= 250) {
          cnt_response = 0;
         }
          else Put_Response();
       }
        // Gest_led ();
//
    }


 }//  FINE PROGRAMMA
 /*

















 */